/* convert interleaved apple // disk file 
 * to non-interleaved and vice versa. 
 */

#include <stdio.h>

main(argc, argv)
int argc;
char **argv;
{
  FILE *fp;
  char buf[16][256];
  int i; 
  int count = 0;
  static int interleave[16] = {
    0x0, 0xe, 0xd, 0xc, 0xb, 0xa, 0x9, 0x8,
    0x7, 0x6, 0x5, 0x4, 0x3, 0x2, 0x1, 0xf};

  if(argc < 1)
    usage();

  while(1)
    {
      for(i=0;i<16;i++)
	{
	  ++count;

	  if(fread(buf[i], 256, 1, stdin) != 1)
	  {
	    fprintf(stderr, "sectors %d\n", count + 1);
	    exit(0);
	  }
	}

      for(i=0; i<16; i++)
	write(1, buf[interleave[i]], 256);

    }
}

usage()
{
  fprintf(stderr, "usage: conv < src > dest\n");
  exit (1);
}
